#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bcmnvram.h"
#include "typedefs.h"  

int main(int argc, char *argv[])
{
    
    
  struct nvram_tuple *srouter_defaults = NULL;
    static unsigned int defaultnum;

    	FILE *in = fopen("defaults_fmk.bin", "rb");

    	if (in == NULL)
        {
             printf("ERROR: Cant open file\n\n");   
             system("PAUSE");
             return 1;
        }
  		
    		
    	defaultnum = (unsigned int)getc(in);
    	defaultnum |= (unsigned int)getc(in) << 8;
    	defaultnum |= (unsigned int)getc(in) << 16;
    	defaultnum |= (unsigned int)getc(in) << 24;

    	int i;
    	srouter_defaults =
    	    (struct nvram_tuple *)malloc(sizeof(struct nvram_tuple) *
    					 defaultnum);
    					 

    				 
    	for (i = 0; i < defaultnum; i++) {
    		unsigned int vl = (unsigned int)getc(in);
    		if (vl) {
    			srouter_defaults[i].name = malloc(vl + 1);
    			fread(srouter_defaults[i].name, vl, 1, in);
    			srouter_defaults[i].name[vl] = 0;
    			vl = (unsigned int)getc(in);
    			if (vl & 128) {
    				vl &= 127;
    				vl |= (unsigned int)getc(in) << 7;
    			}
    			srouter_defaults[i].value = malloc(vl + 1);
    			fread(srouter_defaults[i].value, vl, 1, in);
    			srouter_defaults[i].value[vl] = 0;
    		} else {
    			srouter_defaults[i].name = NULL;
    			srouter_defaults[i].value = NULL;
    		}
    	
    	    printf("Parameter %d: ",i);
    		printf("Name: %c ",srouter_defaults[i].name);
    		printf("Value: %c ",srouter_defaults[i].value);
    		printf("\n");
    	 }
    	fclose(in);
  printf("\n\n\n\n\n");  
  system("PAUSE");	
  return 0;
}
